// Licensed to the .NET Foundation under one or more agreements.
// The .NET Foundation licenses this file to you under the MIT license.
// See the LICENSE file in the project root for more information.


namespace System.Windows.Controls
{
    /// <summary>
    /// Specifies date formats for a DatePicker.
    /// </summary>
    public enum DatePickerFormat
    {
        /// <summary>
        /// Specifies that the date should be displayed using unabbreviated days of the week and month names.
        /// </summary>
        Long = 0,

        /// <summary>
        /// Specifies that the date should be displayed using abbreviated days of the week and month names.
        /// </summary>
        Short = 1
    }
}
