// Licensed to the .NET Foundation under one or more agreements.
// The .NET Foundation licenses this file to you under the MIT license.
// See the LICENSE file in the project root for more information.

using System;
namespace MS.Win32
{
    internal static class ExternDll
    {
        const string SUFFIX =
#if NET4X 
            "_v0400";
#else
            "_cor3";
#endif

        const string PENIMC_SUFFIX =
#if NET4X
            "2" + SUFFIX;
#else 
            SUFFIX;
#endif

        public const string Activeds = "activeds.dll";
        public const string Advapi32 = "advapi32.dll";
        public const string Comctl32 = "comctl32.dll";
        public const string Comdlg32 = "comdlg32.dll";
        public const string DwmAPI = "dwmapi.dll";
        public const string Gdi32 = "gdi32.dll";
        public const string Gdiplus = "gdiplus.dll";
        public const string Hhctrl = "hhctrl.ocx";
        public const string Imm32 = "imm32.dll";
        public const string Kernel32 = "kernel32.dll";
        public const string Loadperf = "Loadperf.dll";
        public const string Mqrt = "mqrt.dll";
        public const string Mscoree = "mscoree.dll";
        public const string MsDrm = "msdrm.dll";
        public const string Mshwgst = "mshwgst.dll";
        public const string Msi = "msi.dll";
        public const string NaturalLanguage6 = "naturallanguage6.dll";
        public const string Ntdll = "ntdll.dll";
        public const string Ole32 = "ole32.dll";
        public const string Oleacc = "oleacc.dll";
        public const string Oleaut32 = "oleaut32.dll";
        public const string Olepro32 = "olepro32.dll";
        public const string Penimc = "PenIMC" + PENIMC_SUFFIX + ".dll";
        public const string PresentationCore = "PresentationCore.dll";
        public const string PresentationFramework = "PresentationFramework.dll";
        public const string PresentationHostDll = "PresentationHost" + SUFFIX + ".dll";
        public const string PresentationNativeDll = "PresentationNative" + SUFFIX + ".dll";
        public const string Psapi = "psapi.dll";
        public const string Shcore = "shcore.dll";
        public const string Shell32 = "shell32.dll";
        public const string Shfolder = "shfolder.dll";
        public const string Urlmon = "urlmon.dll";
        public const string User32 = "user32.dll";
        public const string Uxtheme = "uxtheme.dll";
        public const string Version = "version.dll";
        public const string Vsassert = "vsassert.dll";
        public const string WindowsBase = "windowsbase.dll";
        public const string Wininet = "wininet.dll";
        public const string Winmm = "winmm.dll";
        public const string Winspool = "winspool.drv";
        public const string WpfGfx = "WpfGfx" + SUFFIX + ".dll";
        public const string WtsApi32 = "wtsapi32.dll";
    }
}

